##### JAVA HOME #####
export JAVA_HOME=/usr/jdk/jdk1.8.0_202

##### Server Settings #####

#server_info
SERVER_NAME=server1
JBOSS_HOME=/app/jboss/jboss-eap-7.4
JBOSS_MODULEPATH=${JBOSS_HOME}/modules
DOMAIN_HOME=${JBOSS_HOME}/servers/${SERVER_NAME}

#config_file
CONFIG_FILE=standalone-full-ha.xml

#address_settings
export BIND_ADDR=1.1.1.1
export MGMT_ADDR=${BIND_ADDR}

#port_settings
MGMT_PORT=9100
HTTP_PORT=7010
AJP_PORT=7020
PORT_OFFSET=0

#----------------------------------------------------------------------------

##### log_directory #####
LOG_TIME=$(date +"%Y%m%d_%H_%M")
LOG_DIR=/applog/jboss/jboss_74/standalone/${SERVER_NAME}

#----------------------------------------------------------------------------

##### Multicast IP for stndalone-ha.xml #####

export MULTICAST_ADDR=230.0.0.5
#export JMS_MULTICAST_ADDR=231.20.16.1
#export MODCLUSTER_MULTICAST_ADDR=224.20.16.100

export JAVA_OPTS=" $JAVA_OPTS -Djboss.default.multicast.address=$MULTICAST_ADDR"
#export JAVA_OPTS=" $JAVA_OPTS -Djboss.messaging.group.address=$JMS_MULTICAST_ADDR"
#export JAVA_OPTS=" $JAVA_OPTS -Djboss.modcluster.multicast.address=$MODCLUSTER_MULTICAST_ADDR"

#----------------------------------------------------------------------------

##### JVM Options #####

#server_properties
JAVA_OPTS="${JAVA_OPTS} -Dserver.mode=local"
JAVA_OPTS="${JAVA_OPTS} -Djava.net.preferIPv4Stack=true"
JAVA_OPTS="${JAVA_OPTS} -Djboss.host.name=${HOSTNAME}_${SERVER_NAME}"
JAVA_OPTS="${JAVA_OPTS} -Djboss.node.name=${SERVER_NAME}"
JAVA_OPTS="${JAVA_OPTS} -Djboss.server.base.dir=${DOMAIN_HOME}"
JAVA_OPTS="${JAVA_OPTS} -Djboss.server.log.dir=${LOG_DIR}/serverlog"
JAVA_OPTS="${JAVA_OPTS} -Djboss.bind.address=${BIND_ADDR}"
JAVA_OPTS="${JAVA_OPTS} -Djboss.bind.address.management=${MGMT_ADDR}"
JAVA_OPTS="${JAVA_OPTS} -Djboss.ajp.port=${AJP_PORT}"
JAVA_OPTS="${JAVA_OPTS} -Djboss.http.port=${HTTP_PORT}"
#JAVA_OPTS="${JAVA_OPTS} -Djboss.https.port=${HTTPS_PORT}"
JAVA_OPTS="${JAVA_OPTS} -Djboss.socket.binding.port-offset=${PORT_OFFSET}"

#Djboss.modules.system.pkgs
JAVA_OPTS="${JAVA_OPTS} -Djboss.modules.system.pkgs=org.jboss.byteman"

#heap_memory
JAVA_OPTS="${JAVA_OPTS} -Xms1024m -Xmx1024m -XX:MetaspaceSize=512m -XX:MaxMetaspaceSize=512m"

#gc
JAVA_OPTS="${JAVA_OPTS} -verbose:gc"
JAVA_OPTS="${JAVA_OPTS} -Xloggc:${LOG_DIR}/gc/gc_${SERVER_NAME}.log"
JAVA_OPTS="${JAVA_OPTS} -XX:+PrintGCTimeStamps -XX:+PrintGCDetails -XX:+PrintHeapAtGC"
#disable_default_gc
GC_LOG=false

#heap_dump
JAVA_OPTS="${JAVA_OPTS} -XX:+HeapDumpOnOutOfMemoryError"
JAVA_OPTS="${JAVA_OPTS} -XX:HeapDumpPath=${LOG_DIR}/dump_files/heapdump_${SERVER_NAME}.hprof"

#----------------------------------------------------------------------------

#jennifer5
#JAVA_OPTS="${JAVA_OPTS} -Djennifer.config=/app/jennifer/agent/5.5.2.12/agent.java/conf/jboss74.conf"
#JAVA_OPTS="${JAVA_OPTS} -javaagent:/app/jennifer/agent/5.5.2.12/agent.java/jennifer.jar"
#JAVA_OPTS="${JAVA_OPTS} -Djboss.modules.system.pkgs=org.jboss.byteman,aries,javax.naming,javax.sql,java.sql,java.rmi"

#----------------------------------------------------------------------------

##### user & process check #####

#user running jboss server
JBOSS_USER=midadm

#user check
USER=`whoami`

if [ "${USER}" != "${JBOSS_USER}" ]
then
        echo =============================================
        echo You are not jboss user, Please change user
        echo =============================================
        exit
fi

#process running check
PID=`ps -ef|grep java|grep ${SERVER_NAME}|awk '{print $2}'`

if [ "$PID" != "" ]
then
	echo ""
        echo ==================================================================
        echo "[ServerName:${SERVER_NAME}]"_[pid:"${PID}"] Process Is Already Running !!!
        echo ==================================================================
	echo ""
        exit
fi

#----------------------------------------------------------------------------

##### Server Start #####
export JAVA_OPTS

mv ${LOG_DIR}/stdout/${SERVER_NAME}.out ${LOG_DIR}/stdout/${SERVER_NAME}.out_${LOG_TIME}
mv ${LOG_DIR}/gc/gc_${SERVER_NAME}.log ${LOG_DIR}/gc/gc_${SERVER_NAME}.log_${LOG_TIME}
nohup ${JBOSS_HOME}/bin/standalone.sh --server-config=${CONFIG_FILE} -Djboss.management.http.port=${MGMT_PORT} >> ${LOG_DIR}/stdout/${SERVER_NAME}.out 2>&1 &

echo "================================================="
echo ""
echo "##### Server Startup #####"
echo ""
echo "JBOSS_HOME=${JBOSS_HOME}"
echo "DOMAIN_HOME=${DOMAIN_HOME}"
echo "SERVER_NAME=${SERVER_NAME}"
echo "CONFIG_FILE=${CONFIG_FILE}"
echo "BIND_ADDR=${BIND_ADDR}"
echo "PORT_OFFSET=${PORT_OFFSET}"
echo "MANAGEMENT_CONSOLE=http://${MGMT_ADDR}:${MGMT_PORT}"
echo ""
echo "================================================="
